]> git.pld-linux.org Git - packages/mysql.git/blame - mysql.init
- rel 3
[packages/mysql.git] / mysql.init
CommitLineData
53a28f77 1#!/bin/sh
2#
7429b124 3# mysql A very fast and reliable SQL database engine
53a28f77 4#
7429b124 5# chkconfig: 2345 84 25
53a28f77 6#
350d9d8c 7# description: A very fast and reliable SQL database engine.
0b079830 8
53a28f77 9# Source function library
10. /etc/rc.d/init.d/functions
11
12# Get network config
13. /etc/sysconfig/network
14
aac2c31f
AM
15# Get service config
16if [ -f /etc/sysconfig/mysql ]; then
350d9d8c 17 . /etc/sysconfig/mysql
aac2c31f 18else
350d9d8c 19 nls "Error: %s not found" /etc/sysconfig/mysql
95b0575d 20 nls "%s can't be run." MySQL
350d9d8c
PG
21 exit 1
22fi
23
0146fae1 24if [ -n "$MYSQL_DB_CLUSTERS" ]; then
350d9d8c 25 nls "Warning: MYSQL_DB_CLUSTERS is set. It's obsolete. Use %s instead." /etc/mysql/clusters.conf
aac2c31f
AM
26fi
27
95b0575d 28if [ -f /etc/mysql/clusters.conf ]; then
ca39347b 29 MYSQL_DB_CLUSTERS=$(awk -F= '!/^#/ && /=/{print $2}' /etc/mysql/clusters.conf)
95b0575d
ER
30 if [ -z "$MYSQL_DB_CLUSTERS" ]; then
31 nls "Warning: there are no configured clusters."
32 fi
0146fae1 33
95b0575d 34else
0146fae1 35 nls "Warning: Missing clusters config file %s" /etc/mysql/clusters.conf
95b0575d
ER
36 if [ -z "$MYSQL_DB_CLUSTERS" ]; then
37 nls "Warning: there are no configured clusters."
38 nls "Using default cluster /var/lib/mysql (compatibility mode)"
39 MYSQL_DB_CLUSTERS=/var/lib/mysql
40 fi
aac2c31f
AM
41fi
42
95b0575d 43
ac28c610 44# Check that networking is up
8eb71226 45if is_yes "${NETWORKING}"; then
213fc2f2 46 if [ ! -f /var/lock/subsys/network -a "$1" != stop -a "$1" != status -a "$1" != init ]; then
8eb71226 47 msg_network_down MySQL
48 exit 1
49 fi
50else
51 exit 0
e9ca44ab 52fi
53
aac2c31f
AM
54action="$1"
55
56# any db cluster as command line argument?
521444a9 57if [ $# -gt 1 ]; then
350d9d8c
PG
58 shift
59 # perform action for specified clusters only
30b2aa9a
ER
60 for a in "$@"; do
61 # try auto resolving from /etc/mysql/clusters.conf
62 if [[ "$a" != /* ]]; then
63 m=$(awk -va="$a" -F= 'substr($0, 1, length(a)) == a {print $1}' /etc/mysql/clusters.conf)
64 if [ -z "$m" ]; then
65 echo >&2 "Cluster name '$a' did not match anything!"
66 exit 1
67 fi
68 if [ $(echo "$m" | wc -l) -gt 1 ]; then
69 echo >&2 "Cluster name '$a' ambiguous:" $m
70 exit 1
71 fi
72 a=$(awk -va="$a" -F= 'substr($0, 1, length(a)) == a {print $2}' /etc/mysql/clusters.conf)
73 fi
74 DB_CLUSTERS="$DB_CLUSTERS $a"
75 done
aac2c31f 76else
350d9d8c 77 DB_CLUSTERS="$MYSQL_DB_CLUSTERS"
53a28f77 78fi
79
7c1478d5
ER
80# global error log, if mysqld.conf hasn't migrated to log-error style
81MYSQL_ERRLOG=/var/log/mysql/mysqld.log
c85758f0 82MYSQL_STOP_WAIT_TIME=${MYSQL_STOP_WAIT_TIME:-900}
aac2c31f
AM
83
84#
85# Useful functions.
86#
87
88#
89# check for mysql status
90#
91# arguments:
92# $1 - db cluster
c85758f0 93# $2 - start|stop
aac2c31f
AM
94#
95# sets variables:
c85758f0 96# MYSQL_STATUS = starting | running | not running | died
aac2c31f
AM
97# MYSQL_PID = pid of mysqld process
98#
99mysqlstatus() {
100 clusterdir="$1"
c85758f0
AM
101 mode="$2"
102
096a9b6f 103 mysqlgetconfig "$clusterdir" status
d405c4eb 104
350d9d8c
PG
105 MYSQL_STATUS="not running"
106 MYSQL_PID="unknown"
c85758f0
AM
107 MYSQL_PIDFILE_PID=""
108 MYSQL_GREP_PID=""
aac2c31f 109
c85758f0
AM
110 if [ -f "$MYSQL_PIDFILE" ]; then
111 MYSQL_PIDFILE_PID=$(cat "$MYSQL_PIDFILE")
112 fi
113
114 if [ -n "$MYSQL_PIDFILE_PID" ]; then
115 MYSQL_PID=$MYSQL_PIDFILE_PID
116 if [ ! -d "/proc/$MYSQL_PID" ]; then
117 MYSQL_STATUS="died"
118 return
376ffa12 119 elif (grep -qa "$MYSQL_PIDFILE" /proc/$MYSQL_PID/cmdline 2> /dev/null); then
c85758f0
AM
120 MYSQL_STATUS="running"
121 return
122 fi
123 fi
6d3c5db5 124
c85758f0 125 if [ "$mode" = "start" ]; then
376ffa12 126 MYSQL_GREP_PID=$(grep -lE "^/usr/sbin/mysqld.*${MYSQL_PIDFILE}" /proc/[0-9]*/cmdline 2> /dev/null | awk -F "/" '{ print $3; exit; }')
c85758f0
AM
127 if [ -n "$MYSQL_GREP_PID" ]; then
128 MYSQL_PID=$MYSQL_GREP_PID
0ca65658 129 if grep -qa "$MYSQL_PIDFILE" /proc/$MYSQL_PID/cmdline 2> /dev/null; then
c85758f0
AM
130 if [ -f "$MYSQL_PIDFILE" ]; then
131 MYSQL_PIDFILE_PID=$(cat "$MYSQL_PIDFILE")
132 fi
133 if [ -n "$MYSQL_PIDFILE_PID" ]; then
134 MYSQL_PID=$MYSQL_PIDFILE_PID
135 MYSQL_STATUS="running"
136 return
137 else
138 MYSQL_STATUS="starting"
139 return
140 fi
141 fi
142 fi
6d3c5db5 143 fi
c85758f0
AM
144
145 # else default, "not running"
aac2c31f
AM
146}
147
148# get mysql configuration in variables
5e3157a9 149# MYSQL_CONFIG MYSQL_CLUSTER_DIR
e6d4b62c 150# MYSQL_DATA_DIR MYSQL_USER MYSQL_PIDFILE MYSQL_SOCKET MYSQL_PORT MYSQL_BIND_ADDRESS MYSQL_SKIP_NETWORKING MYSQL_LOG_ERROR
aac2c31f
AM
151#
152# arguments
153# $1 - db cluster
096a9b6f 154# $2 - status | other
aac2c31f
AM
155
156mysqlgetconfig() {
5e3157a9 157 local clusterdir="$1" config_file
096a9b6f 158 local mode="$2"
aac2c31f
AM
159
160 # emulate old behaviour if only one cluster specified
161 if [ "$clusterdir" = "$MYSQL_DB_CLUSTERS" -a "$clusterdir" = "/var/lib/mysql" -a -f /etc/mysqld.conf ]; then
0ca65658 162 MYSQL_RA_COMPAT=yes
aac2c31f 163 config_file=/etc/mysqld.conf
521444a9 164 else
5e3157a9 165 local config=$(awk -F= -vclusterdir="$clusterdir" '!/^#/{ if (clusterdir == $2) print $1}' /etc/mysql/clusters.conf)
0ca65658 166 if [[ $config = /* ]]; then
d54e166d 167 config_file="$config"
fe2f6e01 168 elif [ -f "/etc/mysql/$config" ]; then
0ca65658 169 config_file="/etc/mysql/$config"
d54e166d
AM
170 else
171 config_file="$clusterdir/mysqld.conf"
172 fi
350d9d8c 173 fi
aac2c31f 174
0ca65658 175 MYSQL_CLUSTER_DIR="$clusterdir"
d405c4eb 176
521444a9 177 if [ -z "$config_file" ]; then
f9ad67df 178 nls "Error: Can't find config file for %s cluster" "$clusterdir"
096a9b6f
MM
179 if [ "$mode" = "status" ]; then
180 exit 3
181 else
182 exit 6
183 fi
f9ad67df 184 else
0ca65658 185 MYSQL_CONFIG="$config_file"
f9ad67df 186 fi
d405c4eb 187
aac2c31f
AM
188 if [ ! -f "$config_file" ]; then
189 nls "Error: config file %s not found" "$config_file"
350d9d8c 190 nls "MySQL can't be run. Did you initialize DB by doing \`$0 init'?"
096a9b6f
MM
191 if [ "$mode" = "status" ]; then
192 exit 3
193 else
194 exit 6
195 fi
aac2c31f
AM
196 fi
197
b3be1198 198 # reset to initial state
e6d4b62c 199 MYSQL_DATA_DIR= MYSQL_USER= MYSQL_PIDFILE= MYSQL_SOCKET= MYSQL_PORT= MYSQL_BIND_ADDRESS= MYSQL_SKIP_NETWORKING= MYSQL_LOG_ERROR=
b3be1198
ER
200
201 eval `awk -F= '
ca39347b
ER
202 {
203 # undos
204 gsub(/\r$/, "");
205
206 # trim spaces
3dc69a76
ER
207 gsub(/^[\t ]+|[\t ]+$/, "", $1);
208 gsub(/^[\t ]+|[\t ]+$/, "", $2);
ca39347b
ER
209 }
210
b3be1198
ER
211 # skip comments and empty lines
212 /^[;#]|^ *$/ { next }
213
214 /^[ \t]*\[.*\][ \t]*$/ {
215 match($0, /\[.*\]/);
216 section = substr($0, RSTART + 1, RSTART + RLENGTH - 3);
217 next;
823c13f7 218 }
e9ca44ab 219
b3be1198 220 section == "mysqld" {
3dc69a76 221 if ($1 == "datadir") {
b3be1198 222 printf("MYSQL_DATA_DIR=%s;", $2);
3dc69a76 223 } else if ($1 == "user") {
b3be1198 224 printf("MYSQL_USER=%s;", $2);
3dc69a76 225 } else if ($1 == "pid-file") {
b3be1198 226 printf("MYSQL_PIDFILE=%s;", $2);
3dc69a76 227 } else if ($1 == "socket") {
b3be1198 228 printf("MYSQL_SOCKET=%s;", $2);
3dc69a76 229 } else if ($1 == "port") {
b3be1198 230 printf("MYSQL_PORT=%s;", $2);
3dc69a76 231 } else if ($1 == "bind-address") {
b3be1198 232 printf("MYSQL_BIND_ADDRESS=%s;", $2);
3dc69a76 233 } else if ($1 == "skip-networking") {
9e39a858 234 printf("MYSQL_SKIP_NETWORKING=1;");
3dc69a76 235 } else if ($1 == "log-error") {
e6d4b62c 236 printf("MYSQL_LOG_ERROR=%s;", $2);
b3be1198
ER
237 }
238 }
239 ' $config_file`
e9ca44ab 240
e6d4b62c
ER
241 # error log not defined in config file. add one
242 if [ -z "$MYSQL_LOG_ERROR" ]; then
243 MYSQL_LOG_ERROR=$MYSQL_ERRLOG
244 else
245 # unset, so mysqld would use value from config itself
246 unset MYSQL_LOG_ERROR
247 fi
248
d54e166d 249 if is_yes "$MYSQL_RA_COMPAT"; then
350d9d8c 250 MYSQL_DATA_DIR_SUB=""
8ee1d59c 251 else
350d9d8c 252 MYSQL_DATA_DIR_SUB="/mysqldb"
8ee1d59c 253 fi
d405c4eb 254
8ee1d59c 255 if [ -z "$MYSQL_DATA_DIR" -o "$MYSQL_DATA_DIR" != "${clusterdir}${MYSQL_DATA_DIR_SUB}/db" ]; then
350d9d8c
PG
256 nls "Error: datadir specified in %s should be %s" "$config_file" "$clusterdir${MYSQL_DATA_DIR_SUB}/db"
257 nls " MySQL can't be run."
258 exit 6
8ee1d59c 259 fi
d405c4eb 260
8ee1d59c
AM
261 if [ -z "$MYSQL_PIDFILE" -o "$MYSQL_PIDFILE" != "$clusterdir${MYSQL_DATA_DIR_SUB}/mysql.pid" ]; then
262 nls "Error: pid-file specified in %s should be %s" "$config_file" "$clusterdir${MYSQL_DATA_DIR_SUB}/mysql.pid"
263 nls " MySQL can't be run."
264 exit 6
265 fi
e9ca44ab 266
e6d4b62c 267 if [ -z "$MYSQL_USER" ]; then
350d9d8c
PG
268 echo "$(nls 'MySQL user not configured properly')"'!' >&2
269 nls "Edit %s and configure it." "$config_file" >&2
270 exit 6
860cd80c 271 fi
aac2c31f 272}
e9ca44ab 273
aac2c31f
AM
274# start mysql
275mysqlstart() {
5e3157a9 276 local clusterdir="$1"
aac2c31f
AM
277 mysqlgetconfig "$clusterdir"
278 if [ ! -d "$MYSQL_DATA_DIR/mysql" ]; then
279 nls "MySQL cluster %s not initialized." "$clusterdir"
280 nls "Try \`%s init %s' before start." "$0" "$clusterdir"
350d9d8c
PG
281 exit 6
282 fi
02e96f2e 283
5e3157a9 284 msg_starting "MySQL $clusterdir"; busy
aac2c31f 285 [ -z "$DEFAULT_SERVICE_RUN_NICE_LEVEL" ] && DEFAULT_SERVICE_RUN_NICE_LEVEL=0
c85758f0 286 rm -f "$MYSQL_PIDFILE"
c4fbabf1 287
7c1478d5 288
c4fbabf1 289 TMPDIR=/tmp nice -n ${SERVICE_RUN_NICE_LEVEL:-$DEFAULT_SERVICE_RUN_NICE_LEVEL} \
7429b124 290 /usr/bin/setsid /usr/sbin/mysqld \
c4fbabf1
ER
291 --defaults-file=$MYSQL_CONFIG \
292 --datadir=$MYSQL_DATA_DIR \
7c1478d5 293 --pid-file=$MYSQL_PIDFILE \
e6d4b62c 294 ${MYSQL_LOG_ERROR:+--log-error="$MYSQL_LOG_ERROR"} \
7c1478d5 295 $MYSQL_OPTIONS &
c4fbabf1
ER
296 pid=$!
297
298 sleep 0.1
c85758f0
AM
299 mysqlstatus "$clusterdir" start
300 # it takes longer for mysqld to start and create pidfile if it has to recover innodb transactions
301 if [ "$MYSQL_STATUS" = "starting" ]; then
c4fbabf1
ER
302 echo ""
303 show "Waiting for MySQL to start"
304 busy
305
306 # while the pid is running, mysql is starting up
307 # if the pidfile was created, it started up successfully
308 # if either case fails we break and report status
309 while true; do
310 [ -d /proc/$pid ] || break
c85758f0 311 [ -f "$MYSQL_PIDFILE" ] && break
c4fbabf1 312 sleep 0.2
c85758f0
AM
313 done
314 fi
315
316 mysqlstatus "$clusterdir" start
6d3c5db5 317 if [ "$MYSQL_STATUS" = "running" -a "$MYSQL_PID" != "unknown" ]; then
aac2c31f 318 ok
47fd5a6a 319 elif [ "$MYSQL_STATUS" = "died" ]; then
350d9d8c 320 RETVAL=1
47fd5a6a 321 died
aac2c31f
AM
322 else
323 RETVAL=1
324 fail
53a28f77 325 fi
aac2c31f
AM
326}
327
328# stop mysql
329mysqlstop() {
5e3157a9 330 local clusterdir="$1"
c85758f0 331 mysqlstatus "$clusterdir" stop
aac2c31f
AM
332 msg_stopping "MySQL $clusterdir"
333 busy
95b0575d 334
95b0575d 335 # try graceful shutdown -- send shutdown command
566e62bb 336 # requires mysql_sysadmin user proper privs
465c110e 337 /usr/bin/mysqladmin --defaults-file=$MYSQL_CONFIG ${MYSQL_SOCKET:+--socket=$MYSQL_SOCKET} shutdown >/dev/null 2>&1
c85758f0 338 mysqlstatus "$clusterdir" stop
95b0575d 339
c85758f0
AM
340 if [ "$MYSQL_PID" != "unknown" ]; then
341 kill -TERM "$MYSQL_PID" 2> /dev/null
342 for nr in $(seq 1 $(($MYSQL_STOP_WAIT_TIME*10))); do
343 [ -d "/proc/$MYSQL_PID" ] || break
344 sleep 0.1
345 done
346 fi
347
348 mysqlstatus "$clusterdir" stop
47fd5a6a 349 if [ "$MYSQL_STATUS" = "died" ]; then
350d9d8c 350 died
c85758f0 351 elif [ "$MYSQL_STATUS" = "running" -o "$MYSQL_STATUS" = "starting" ]; then
aac2c31f 352 fail
b92e5cd1 353 else
aac2c31f 354 ok
b92e5cd1 355 fi
aac2c31f
AM
356}
357
70cdc654
ER
358# report slave status
359# uses MYSQL_SOCKET - path to mysql socket
360slave_status() {
361 # see if slave status can be reported
ed3eec1b 362 local err=0 slave_status=$(mysql --defaults-file="$MYSQL_CONFIG" --socket="$MYSQL_SOCKET" -e 'show slave status\G')
70cdc654
ER
363 if [ -z "$slave_status" ]; then
364 # slave not setup
365 return
366 fi
367
288d6415 368 printf "Slave Status:\n"
70cdc654 369
7c5ef922 370 set -f
70cdc654
ER
371 eval $(echo "$slave_status" | awk -F': ' '/^ *[A-Za-z_]+:/{
372 k = tolower($1);
373 v = substr($0, length($1) + 3);
374 gsub(/\\/, "\\\\\\", v);
375 gsub(/"/, "\\\"", v);
376 gsub(/`/, "\\`", v);
377 gsub(/\$/, "\\$", v);
7c5ef922 378 gsub(/\$/, "\\$", v);
70cdc654
ER
379 printf("%s=\"%s\";\n", k, v);
380 }')
7c5ef922 381 set +f
70cdc654
ER
382
383 if [ "$slave_io_running" != "Yes" ]; then
384 printf "\tSlave IO not running\n"
385 err=1
386 fi
387 if [ "$slave_sql_running" != "Yes" ]; then
388 printf "\tSlave SQL not running\n"
389 err=1
390 fi
391
392 if [ "$err" = 1 -a "$last_errno" -gt 0 ]; then
7c5ef922 393 printf "\tERROR %s: %s\n" "$last_errno" "$last_error"
70cdc654
ER
394 fi
395
396 if [ "$master_log_file" != "$relay_master_log_file" ]; then
7c5ef922 397 printf "\tERROR logfile mismatch (%s)\n" "$relay_master_log_file"
70cdc654
ER
398 err=1
399 fi
400
401 if [ -z "$read_master_log_pos" -o -z "$exec_master_log_pos" ]; then
402 printf "\tERROR No info about master\n"
403 err=1
404 return
405 fi
406
407 diff=$(($read_master_log_pos - $exec_master_log_pos))
7c5ef922
ER
408 printf "\tread pos: %s (%s) (host: %s:%d)\n" "$read_master_log_pos" "$master_log_file" "$master_host" "$master_port"
409 printf "\texec pos: %s\n" "$exec_master_log_pos"
410 printf "\tdiff: %s\n" "$diff"
70cdc654
ER
411}
412
aac2c31f
AM
413#
414# check for running mysql instances; if any instance is running then
415# create subsys lock file
416#
417mysqlsubsys() {
350d9d8c
PG
418 # check for every defined db cluster in sysconfig file
419 for mysqldir in $DB_CLUSTERS; do
420 mysqlstatus "$mysqldir"
421 if [ "$MYSQL_STATUS" = "running" ]; then
422 touch /var/lock/subsys/mysql
423 return
424 fi
425 done
426 rm -f /var/lock/subsys/mysql
aac2c31f
AM
427}
428
429mysqlinit() {
5e3157a9 430 local clusterdir="$1"
8ee1d59c
AM
431
432 if [ -f /etc/mysqld.conf ]; then
350d9d8c
PG
433 nls "Running in \`no cluster compat' mode: can't initialize database."
434 nls "Move /etc/mysqld.conf away and rerun \`$0 init' (new config will be in $clusterdir)."
435 exit 1
8ee1d59c
AM
436 fi
437
521444a9
AM
438 if [ -f "$clusterdir/mysqld.conf" ]; then
439 mysqlgetconfig "$clusterdir"
440 else
441 MYSQL_USER="mysql"
442 MYSQL_CLUSTER_DIR="$clusterdir"
443 MYSQL_DATA_DIR="$clusterdir/mysqldb/db"
444 MYSQL_PIDFILE="$clusterdir/mysqldb/mysql.pid"
445 MYSQL_SOCKET="$clusterdir/mysqldb/mysql.sock"
fe98cc4a
ER
446
447 # this $MYSQL_CONFIG will be created later
448 MYSQL_CONFIG="$MYSQL_CLUSTER_DIR/mysqld.conf"
521444a9 449 fi
aac2c31f 450
092832b7 451 show "Initializing cluster %s" "$clusterdir"; started
aac2c31f 452
573e1dcc 453 # Check if not exist init database
e9ca44ab 454 if [ -d "$MYSQL_DATA_DIR/mysql" ]; then
c70c8930 455 nls "Seems that database is initialized now. Remove by hand %s" "$MYSQL_DATA_DIR/mysql"
b92e5cd1 456 nls "before initializing database."
aac2c31f 457 nls "For now skipping cluster %s." "$clusterdir"
df1ac9e1 458 exit 6
e9ca44ab 459 fi
460
5f961775 461 show "Installing MySQL system tables for $MYSQL_DATA_DIR"
e9ca44ab 462 busy
d405c4eb
JB
463 TMP=/tmp TMPDIR=/tmp
464
c4fbabf1 465 mkdir -p "$MYSQL_DATA_DIR" > /dev/null 2>&1
f5d63301
AM
466 # Using mysql:mysql for MYSQL_CLUSTER_DIR is creating SECURITY hole, root:root is proper
467 chown root:root "$MYSQL_CLUSTER_DIR"
5f961775 468 chown mysql:mysql "$MYSQL_CLUSTER_DIR/mysqldb" "$MYSQL_DATA_DIR" > /dev/null 2>&1
653cf157 469 chmod 751 "$MYSQL_CLUSTER_DIR" "$MYSQL_CLUSTER_DIR/mysqldb"
444f9f3c 470
72fb98c6 471 if [ -f /usr/share/percona-server/mysqld.conf -a ! -f "$MYSQL_CLUSTER_DIR/mysqld.conf" ]; then
b6369c60
ER
472 sed -e "
473 s#\(datadir.*\)=.*#\1= $MYSQL_DATA_DIR#g;
474 s#\(pid-file.*\)=.*#\1= $MYSQL_PIDFILE#g;
475 s#\(socket.*\)=.*#\1= $MYSQL_SOCKET#g;
476 s#@clusterdir@#$MYSQL_CLUSTER_DIR#g;
72fb98c6 477 " /usr/share/percona-server/mysqld.conf > "$MYSQL_CLUSTER_DIR/mysqld.conf"
54a1f368 478 chown root:root "$MYSQL_CLUSTER_DIR/mysqld.conf"
444f9f3c
AM
479 chmod 640 "$MYSQL_CLUSTER_DIR/mysqld.conf"
480 fi
cc4d3f78 481
a08fc1eb 482 if [ ! -e /var/lib/mysql/mysql.sock ] || [ -L /var/lib/mysql/mysql.sock ] && [ -z "$(readlink /var/lib/mysql/mysql.sock)" ]; then
0ca65658 483 sock=${MYSQL_SOCKET#/var/lib/mysql/} # make it relative if possible
5fe13e55 484 ln -s "$sock" /var/lib/mysql/mysql.sock
cc4d3f78 485 fi
aac2c31f 486
b9c4f95d 487 cat > $MYSQL_DATA_DIR/mysql-init.sql <<-EOF
bb39d376 488 CREATE DATABASE mysql;
4444725f 489 use mysql;
72fb98c6
AM
490 $(cat /usr/share/percona-server/mysql_system_tables.sql)
491 $(sed -e "/@current_hostname/d" /usr/share/percona-server/mysql_system_tables_data.sql)
b9c4f95d
ER
492EOF
493
494 ok=0
5ab9fb7b
JR
495 /usr/sbin/mysqld \
496 --defaults-file=$MYSQL_CLUSTER_DIR/mysqld.conf \
497 --bootstrap \
498 --skip-grant-tables \
499 --datadir=$MYSQL_DATA_DIR \
500 --user=$MYSQL_USER \
501 --slave-load-tmpdir=$MYSQL_DATA_DIR \
502 --tmpdir=$MYSQL_DATA_DIR \
503 --log-error=$MYSQL_ERRLOG \
da87c30d 504 < $MYSQL_DATA_DIR/mysql-init.sql && ok=1
4845ab08 505 [ -f $MYSQL_DATA_DIR/mysql/user.frm ] || ok=0
c4fbabf1 506
b9c4f95d
ER
507 if [ "$ok" = 1 ]; then
508 rm -f $MYSQL_DATA_DIR/mysql-init.sql
5f961775
JR
509 ok
510 cat << END_OF_MSG
6a46c354 511
512PLEASE REMEMBER TO SET A PASSWORD FOR THE MySQL USERS!
5f961775
JR
513This is done, after starting database, in the order shown,
514with:
515
516For 'mysql_sysadmin' (RELOAD and SHUTDOWN privileges):
517echo "update mysql.user set password=password('newpassword') where user='mysql_sysadmin'; FLUSH PRIVILEGES;" | mysql -u mysql -S $MYSQL_SOCKET
6a46c354 518
5f961775
JR
519For 'mysql' user (ALL privileges, DB admin):
520echo "update mysql.user set password=password('newpassword') where user='mysql'; FLUSH PRIVILEGES;" | mysql -u mysql -S $MYSQL_SOCKET
6a46c354 521
566e62bb 522NOTE: mysql_sysadmin password should be placed to $MYSQL_CONFIG in
6a46c354 523mysqladmin section. See the manual for more instructions.
566e62bb 524(This user is used at logs rotation and server shutdown)
e9ca44ab 525
5f961775
JR
526END_OF_MSG
527 show "Filling help tables..."
528 ok=0
72fb98c6 529 ( echo "use mysql;"; cat /usr/share/percona-server/fill_help_tables.sql ) | \
9b5b7a74
ER
530 /usr/sbin/mysqld \
531 --defaults-file=$MYSQL_CLUSTER_DIR/mysqld.conf \
532 --bootstrap \
533 --skip-grant-tables \
9b5b7a74
ER
534 --datadir=$MYSQL_DATA_DIR \
535 --user=$MYSQL_USER \
536 --slave-load-tmpdir=$MYSQL_DATA_DIR \
537 --tmpdir=$MYSQL_DATA_DIR \
538 --log-error=$MYSQL_ERRLOG \
da87c30d 539 && ok=1
5f961775
JR
540 if [ "$ok" = 1 ]; then
541 ok
542 else
543 cat << END_OF_MSG
544
545WARNING: HELP FILES ARE NOT COMPLETELY INSTALLED!
546The "HELP" command might not work properly.
16bf26ff 547
e9ca44ab 548END_OF_MSG
5f961775
JR
549 fi
550 else
551 fail
552 cat << END_OF_MSG
4ff46415
AM
553ERROR:
554ERROR:
555ERROR: Installation of grant tables FAILED!
556ERROR:
557ERROR:
e9ca44ab 558
6df74636
ER
559The initialization SQL script was preserved at $MYSQL_DATA_DIR/mysql-init.sql
560
b9c4f95d
ER
561Examine the logs in /var/log/mysql for more information. You can
562also try to start the mysqld daemon with:
e9ca44ab 563
564/usr/sbin/mysqld --skip-grant &
565
dc7a177f 566You can use the command line tool mysql to connect to the mysql
e9ca44ab 567database and look at the grant tables:
568
dc7a177f 569shell> mysql -u mysql mysql
e9ca44ab 570mysql> show tables
571
572Try 'mysqld --help' if you have problems with paths. Setting on
4581ca2d 573logging in $MYSQL_DATA_DIR/mysqld.conf gives you a log in /var/log/mysql/query.log that
e9ca44ab 574may be helpful. The latest information about MySQL is available on the
78b16243 575web at http://www.mysql.com/.
e9ca44ab 576
a3eb9e7b 577Please check PLD Linux ftp site for newer versions of this package.
e9ca44ab 578
579Please consult the MySQL manual section: 'Problems running
580mysql_install_db', and the manual section that describes problems on
581your OS. Another information source is the MySQL email archive.
e9ca44ab 582
583END_OF_MSG
5f961775 584 exit 1
aac2c31f
AM
585 fi
586}
587
588#
589# End of useful functions.
590#
591
323256af 592start() {
5e3157a9 593 local mysqldir
aac2c31f 594 for mysqldir in $DB_CLUSTERS; do
c85758f0 595 mysqlstatus "$mysqldir" start
aac2c31f
AM
596 if [ "$MYSQL_STATUS" = "running" ]; then
597 msg_already_running "MySQL $mysqldir"
598 else
599 mysqlstart "$mysqldir"
600 fi
601 done
602 mysqlsubsys
323256af
ER
603}
604
605stop() {
5e3157a9 606 local mysqldir
aac2c31f 607 for mysqldir in $DB_CLUSTERS; do
c85758f0 608 mysqlstatus "$mysqldir" stop
aac2c31f
AM
609 if [ "$MYSQL_STATUS" = "not running" ]; then
610 msg_not_running "MySQL $mysqldir"
611 else
612 mysqlstop "$mysqldir"
613 fi
614 done
615 mysqlsubsys
323256af
ER
616}
617
7429b124 618condrestart() {
5e3157a9 619 if [ ! -f /var/lock/subsys/mysql ]; then
7429b124
JB
620 msg_not_running "MySQL"
621 RETVAL=$1
5e3157a9 622 return
7429b124 623 fi
5e3157a9
ER
624
625 stop
626 start
7429b124
JB
627}
628
0d6ce890 629status() {
8b768513 630 local mysqldir addr port socket pid pids running datadir
0e94191b 631 RETVAL=3
aac2c31f
AM
632 for mysqldir in $DB_CLUSTERS; do
633 mysqlstatus "$mysqldir"
2bac5c2d 634 if [ "$MYSQL_STATUS" = "running" ]; then
0e94191b 635 RETVAL=0
b3be1198
ER
636 addr=${MYSQL_BIND_ADDRESS:-0.0.0.0}
637 port=${MYSQL_PORT:-3306}
638 socket=${MYSQL_SOCKET:-/var/lib/mysql/mysql.sock}
639 pid=$MYSQL_PID
9e39a858
ER
640 nls "MySQL cluster %s, pid %s\n" "$mysqldir" "$pid"
641 [ -z "$MYSQL_SKIP_NETWORKING" ] && nls "\ttcp:%s:%s\n" "$addr" "$port"
bb821a4c 642 nls "\tunix: %s\n" "$socket"
70cdc654
ER
643
644 MYSQL_SOCKET=$socket slave_status
645
b2bb6a82 646 pids="$pids/$MYSQL_PID/"
2bac5c2d
ER
647 progress "$MYSQL_STATUS"
648 else
27698ac1 649 show "MySQL cluster %s" "$mysqldir"
2bac5c2d
ER
650 progress "$MYSQL_STATUS" "$CFAIL"
651 fi
652 echo
aac2c31f 653 done
b2bb6a82
ER
654
655 for pid in $(/sbin/pidof mysqld); do
656 if [[ $pids != */$pid/* ]]; then
657 running="$running $pid"
658 fi
659 done
b7d0a657 660
a5595931 661 if [ $# = 1 -a "$running" ]; then
b2bb6a82
ER
662 nls "Warning: MySQL Daemon processes not under clusters.conf control:"
663 # see if we can display their status
664 for pid in $running; do
b7d0a657 665 datadir=$(cat /proc/$pid/cmdline | tr '\0' '\n' | fgrep -- --datadir=)
b2bb6a82
ER
666 datadir=${datadir#--datadir=} # strip --datadir
667 mysqldir=${datadir%/mysqldb/db} # strip /mysqldb/db
668 mysqlstatus "$mysqldir"
669 if [ "$MYSQL_STATUS" = "running" ]; then
b3be1198
ER
670 addr=${MYSQL_BIND_ADDRESS:-0.0.0.0}
671 port=${MYSQL_PORT:-3306}
672 socket=${MYSQL_SOCKET:-/var/lib/mysql/mysql.sock}
9e39a858
ER
673 nls "MySQL cluster %s, pid %s\n" "$mysqldir" "$pid"
674 [ -z "$MYSQL_SKIP_NETWORKING" ] && nls "\ttcp:%s:%s\n" "$addr" "$port"
bb821a4c 675 nls "\tunix: %s\n" "$socket"
70cdc654
ER
676
677 MYSQL_SOCKET=$socket slave_status
678
b2bb6a82
ER
679 progress "$MYSQL_STATUS"
680 else
681 show "MySQL cluster %s" "$mysqldir"
682 progress "$MYSQL_STATUS" "$CFAIL"
683 fi
684 echo
685 done
686 fi
0d6ce890
ER
687}
688
689RETVAL=0
690case "$action" in
691 start)
692 start
693 ;;
694 stop)
695 stop
696 ;;
697 restart)
698 stop
699 start
700 ;;
701 try-restart)
702 condrestart 0
703 ;;
704 force-reload)
705 condrestart 7
706 ;;
707 init)
708 for mysqldir in $DB_CLUSTERS; do
709 mysqlinit "$mysqldir"
710 done
711 exit $?
712 ;;
713 flush-logs)
714 for mysqldir in $DB_CLUSTERS; do
715 mysqlgetconfig "$mysqldir"
716 # just if mysqld is really running
717 if /usr/bin/mysqladmin --defaults-file="$MYSQL_CONFIG" --socket="$MYSQL_SOCKET" ping >/dev/null 2>&1; then
718 /usr/bin/mysqladmin --defaults-file="$MYSQL_CONFIG" --socket="$MYSQL_SOCKET" flush-logs
719 fi
720 done
721 ;;
722 status)
723 status
aac2c31f 724 ;;
53a28f77 725 *)
33cdd78d 726 msg_usage "$0 {start|stop|restart|try-restart|force-reload|init|flush-logs|status}"
02e96f2e 727 exit 3
53a28f77 728esac
40c36bca 729
ee9b6a50 730exit $RETVAL
This page took 0.232546 seconds and 4 git commands to generate.